# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

variables:
  #Default variables
  RELEASE: "ER1.2"
  SOC: "2"
  FLAGS: "-f"
  SKIP_FLASH: "1"

stages: 
  - flash
  - setup         # List of stages for jobs, and their order of execution
  - run-tests

flash-qdrive3:
  stage: flash
  tags:
    - SIDEKICK
  #TODO use tags to specify ER to flash?
  script:
    #- bash /root/ER2/flash_qdrive3.sh -r /root/ER1.2/auto-osbuild-qemu-rhel9-developer-regular-aarch64-2391864.fe46202f.ext4.simg -b /root/ER1.2/sa8540p-boot.img -s2
    #- bash /root/ER2/flash_qdrive3.sh -l ER1.2 -s 2
    - bash /root/ER2/flash_qdrive3.sh -l $RELEASE -s $SOC
  except:
    variables:
      - $SKIP_FLASH

setup-qdrive3:
  stage: setup
  tags:
    - SIDEKICK
  #  #TODO use ansible provision script to setup Qdrive3
  script:
    - echo "Setting up Qdrive3..."
    - git clone https://gitlab.com/redhat/edge/tests/pts-demo/perf-sut-bootstrap.git
    - ansible-playbook -u root --extra-vars "ansible_ssh_pass=password" -i 10.16.2.164, /root/perf-sut-bootstrap/common_bootstrap.yml
    - echo "Qdrive3 setup completed."

10-cont-seq:       # This job runs in the build stage, which runs first.
  stage: run-tests
  tags:
    - HW:AWS
    - OS:RHIVOS-ER2.0
  script:
    - sudo dnf install -y make gcc python3 podman
    - sudo python3 ./run.py $FLAGS 10 10
  after_script:
    - sudo chown gitlab-runner -R ./data
  artifacts:
    paths:
      - ./data
    when: always

10-cont-parallel:       # This job runs in the build stage, which runs first.
  stage: run-tests
  tags:
    - HW:AWS
    - OS:RHIVOS-ER2.0
  script:
    - sudo dnf install -y make gcc python3 podman
    - sudo python3 ./run.py $FLAGS -p 10 10
  after_script:
    - sudo chown gitlab-runner -R ./data
  artifacts:
    paths:
      - ./data
    when: always

#unit-test-job:   # This job runs in the test stage.
#  stage: test    # It only starts when the job in the build stage completes successfully.
#  script:
#    - echo "Running unit tests... This will take about 60 seconds."
#    - sleep 60
#    - echo "Code coverage is 90%"
#
#lint-test-job:   # This job also runs in the test stage.
#  stage: test    # It can run at the same time as unit-test-job (in parallel).
#  script:
#    - echo "Linting code... This will take about 10 seconds."
#    - sleep 10
#    - echo "No lint issues found."
#
#deploy-job:      # This job runs in the deploy stage.
#  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
#  environment: production
#  script:
#    - echo "Deploying application..."
#    - echo "Application successfully deployed."
